def is_goodpar(E):
    pile = []
    for i in E:
        if i == '(' or i == '[':
            pile.append(i)
        elif i == ')':
            if pile[-1] == '(':
                del pile[-1]
            else:
                return False
        elif i == ']':
            if pile[-1] == '[':
                del pile[-1]
            else:
                return False
    if len(pile) == 0:
        return True